jQuery(document).ready(function() {
	
	//bind rebuild meta button
	jQuery('#nfpmgm_rebuild_meta_button').click(function(){
		
		jQuery('.nfpmgm-ending-meta-rebuild').hide();
		jQuery('.nfpmgm-preparing-meta-rebuild').show();
		jQuery('#nfpmgm_rebuild_meta_button').prop('disabled', true);
		
		var nfpmgm_rebuild_all_meta = 0;
		if(jQuery('#nfpmgm_rebuild_all_meta').prop('checked') === true) {
			
			nfpmgm_rebuild_all_meta = 1;
		}
				
		var nfpmgm_rebuild_pdf_meta = 0;
		if(jQuery('#nfpmgm_rebuild_pdf_meta').prop('checked') === true) {
			
			nfpmgm_rebuild_pdf_meta = 1;
			
		}
	
		//get media to work with
		jQuery.ajax({
			type: 'POST',
			dataType: 'json',
			url: nfpmgm_meta_rebuild_object.nfpmgm_meta_rebuild_url,
			data: {
				'action': 'nfpmgm_meta_rebuild',
				'nfpmgm_meta_rebuild_nonce': nfpmgm_meta_rebuild_object.nfpmgm_meta_rebuild_nonce,
				'nfpmgm_rebuild_all_meta': nfpmgm_rebuild_all_meta
			},
			
			//deal with success
			success:function(data){
				
				//count ids
				var nfpmgmEntriesToWorkWith = data.length;
				
				if(nfpmgmEntriesToWorkWith === 0) {
					
					//no image needs to be treated
					jQuery('.nfpmgm-preparing-meta-rebuild').hide();
					jQuery('.nfpmgm-ending-meta-rebuild').show();
					jQuery('#nfpmgm_rebuild_meta_button').prop('disabled', false);
					//console.log("no image to work with");
					return;
					
				} else {
					
					nfpmgmEntriesToWorkWith = data['id'].length;
					
					jQuery('.nfpmgm-preparing-meta-rebuild').hide();
					jQuery('.nfpmgm-executing-current-meta').text('1');
					jQuery('.nfpmgm-executing-total-meta').text(nfpmgmEntriesToWorkWith);
					jQuery('.nfpmgm-executing-meta-rebuild').show();
					
					//console.log(nfpmgmEntriesToWorkWith+' meta to work with');
					
				}
							
												
				//define a viariable to count loops
				var nfpmgmRebuildReiterances = 0;				
				
				function nfpmgmRebuildMeta(nfpmgmEntriesToWorkWith,nfpmgmRebuildReiterances) {

					var nfpmgmImagesIds = data['id'];

					var nfpmgmInvolvedImageId = nfpmgmImagesIds[nfpmgmRebuildReiterances];

					//console.log(nfpmgmRebuildReiterances+": treating "+nfpmgmInvolvedImageId);		
								
					jQuery.ajax({
						type: 'POST',
						dataType: 'json',
						url: nfpmgm_meta_rebuild_object.nfpmgm_meta_rebuild_url,
						data: {
							'action': 'nfpmgm_meta_rebuild',
							'nfpmgm_meta_rebuild_nonce': nfpmgm_meta_rebuild_object.nfpmgm_meta_rebuild_nonce,
							'nfpmgm_rebuild_all_meta': nfpmgm_rebuild_all_meta,
							'nfpmgm_current_image_id': nfpmgmInvolvedImageId
						},
						
						//deal with success
						success:function(data) {
							
							nfpmgmRebuildReiterances++;
																
							if(nfpmgmRebuildReiterances < nfpmgmEntriesToWorkWith) {
								
								setTimeout(function() {
								
									jQuery('.nfpmgm-executing-current-meta').text(nfpmgmRebuildReiterances+1);																
									nfpmgmRebuildMeta(nfpmgmEntriesToWorkWith,nfpmgmRebuildReiterances);
									
								}, 125);									
							
							}
							
							else if(nfpmgmRebuildReiterances === nfpmgmEntriesToWorkWith) {

								jQuery('#nfpmgm_rebuild_meta_button').prop('disabled', false);
								jQuery('.nfpmgm-executing-meta-rebuild').hide();
								jQuery('.nfpmgm-ending-meta-rebuild').show();
								
								//console.log("job completed")
								return;								
								
							}
							
						},
						
						//deal with errors
						error: function(errorThrown){
							console.log(errorThrown);
						},

					}); 
				
				};
									
				nfpmgmRebuildMeta(nfpmgmEntriesToWorkWith,nfpmgmRebuildReiterances);

										
			},
			
			error: function(errorThrown){
				console.log(errorThrown);
			}
			
		});		
		
		
	})
              
});